/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Pid.xs. Do not edit this file, edit Pid.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Linux/FD/Pid.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <signal.h>
#include <linux/wait.h>
#include <sys/syscall.h>
#include <unistd.h>

#define die_sys(format) Perl_croak(aTHX_ format, strerror(errno))

static SV* S_io_fdopen(pTHX_ int fd, const char* classname, char type) {
	PerlIO* pio = PerlIO_fdopen(fd, "r");
	GV* gv = newGVgen(classname ? classname : "Linux::FD::Pid");
	SV* ret = newRV_noinc((SV*)gv);
	IO* io = GvIOn(gv);
	IoTYPE(io) = type;
	IoIFP(io) = pio;
	IoOFP(io) = pio;
	if (classname) {
		HV* stash = gv_stashpv(classname, FALSE);
		sv_bless(ret, stash);
	}
	return ret;
}
#define io_fdopen(fd, classname, type) S_io_fdopen(aTHX_ fd, classname, type)

static char S_get_flags(pTHX_ int fd) {
	struct stat info;
	if (fstat(fd, &info) != -1) {
		if (S_ISSOCK(info.st_mode))
			return 's';
		else if (S_ISFIFO(info.st_mode))
			return '|';
	}

	int flags = fcntl(fd, F_GETFL);
	if (flags & O_APPEND)
		return 'a';
	switch (flags & 3) {
		case O_RDONLY:
			return '<';
		case O_WRONLY:
			return '>';
		case O_RDWR:
			return '+';
		default:
			close(fd);
			Perl_croak(aTHX_ "Unknown mode on descriptor");
	}
}
#define get_flags(fd) S_get_flags(aTHX_ fd)

typedef struct { const char* key; unsigned long value; } map[];

#define PIDFD_NONBLOCK O_NONBLOCK
static map pid_flags = {
	{ "non-blocking", PIDFD_NONBLOCK },
};

static UV S_get_pid_flag(pTHX_ SV* flag_name) {
	int i;
	for (i = 0; i < sizeof pid_flags / sizeof *pid_flags; ++i)
		if (strEQ(SvPV_nolen(flag_name), pid_flags[i].key))
			return pid_flags[i].value;
	Perl_croak(aTHX_ "No such flag '%s' known", SvPV_nolen(flag_name));
}
#define get_pid_flag(name) S_get_pid_flag(aTHX_ name)

#define get_fd(self) PerlIO_fileno(IoOFP(sv_2io(SvRV(self))))

#line 83 "lib/Linux/FD/Pid.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 227 "lib/Linux/FD/Pid.c"

XS_EUPXS(XS_Linux__FD__Pid_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Pid_new)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "classname, pid, ...");
    {
	const char*	classname = (const char *)SvPV_nolen(ST(0))
;
	int	pid = (int)SvIV(ST(1))
;
#line 86 "lib/Linux/FD/Pid.xs"
	int pidfd;
	int i, flags = 0;
#line 243 "lib/Linux/FD/Pid.c"
	SV *	RETVAL;
#line 89 "lib/Linux/FD/Pid.xs"
	for (i = 2; i < items; i++)
		flags |= get_pid_flag(ST(i));
	pidfd = syscall(__NR_pidfd_open, pid, 0);
	if (pidfd < 0)
		die_sys("Couldn't open pidfd: %s");
	RETVAL = io_fdopen(pidfd, classname, '<');
#line 252 "lib/Linux/FD/Pid.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD__Pid_send); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Pid_send)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "file_handle, signal");
    {
	SV*	file_handle = ST(0)
;
	SV*	signal = ST(1)
;
#line 103 "lib/Linux/FD/Pid.xs"
		int fd, ret;
#line 273 "lib/Linux/FD/Pid.c"
#line 105 "lib/Linux/FD/Pid.xs"
		fd = get_fd(file_handle);
		int signo = (SvIOK(signal) || looks_like_number(signal)) && SvIV(signal) ? SvIV(signal) : whichsig(SvPV_nolen(signal));
		ret = syscall(__NR_pidfd_send_signal, fd, signo, NULL, 0);
		if (ret < 0)
			die_sys("Couldn't send signal: %s");
#line 280 "lib/Linux/FD/Pid.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__FD__Pid_wait); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Pid_wait)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "file_handle, flags = WEXITED");
    {
	SV*	file_handle = ST(0)
;
	int	flags;
#line 116 "lib/Linux/FD/Pid.xs"
		int fd, wait_result;
		siginfo_t info;
#line 299 "lib/Linux/FD/Pid.c"
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    flags = WEXITED;
	else {
	    flags = (int)SvIV(ST(1))
;
	}
#line 119 "lib/Linux/FD/Pid.xs"
		fd = get_fd(file_handle);
		wait_result = waitid(P_PIDFD, fd, &info, flags);
		if (wait_result != 0) {
			if (errno == EAGAIN)
				XSRETURN_UNDEF;
			else
				die_sys("Can't wait pid: %s");
		}
		if (info.si_signo == 0)
			XSRETURN_UNDEF;
		if (info.si_code == CLD_EXITED)
			RETVAL = info.si_status << 8;
		else
			RETVAL = info.si_status;
#line 324 "lib/Linux/FD/Pid.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD__Pid_get_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Pid_get_handle)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "file_handle, fd");
    {
	SV*	file_handle = ST(0)
;
	int	fd = (int)SvIV(ST(1))
;
#line 141 "lib/Linux/FD/Pid.xs"
		int pidfd, newfd;
#line 345 "lib/Linux/FD/Pid.c"
	SV *	RETVAL;
#line 143 "lib/Linux/FD/Pid.xs"
		pidfd = get_fd(file_handle);
		newfd = syscall(__NR_pidfd_getfd, pidfd, fd, 0);
		if (newfd < 0)
			die_sys("Can't get file descriptor: %s");
		RETVAL = io_fdopen(newfd, NULL, get_flags(newfd));
#line 353 "lib/Linux/FD/Pid.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Linux__FD__Pid); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Linux__FD__Pid)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Linux::FD::Pid::new", XS_Linux__FD__Pid_new);
        newXS_deffile("Linux::FD::Pid::send", XS_Linux__FD__Pid_send);
        newXS_deffile("Linux::FD::Pid::wait", XS_Linux__FD__Pid_wait);
        newXS_deffile("Linux::FD::Pid::get_handle", XS_Linux__FD__Pid_get_handle);

    /* Initialisation Section */

#line 78 "lib/Linux/FD/Pid.xs"
    load_module(PERL_LOADMOD_NOIMPORT, newSVpvs("IO::Handle"), NULL);
    av_push(get_av("Linux::FD::Pid::ISA" , GV_ADD), newSVpvs("IO::Handle"));

#line 399 "lib/Linux/FD/Pid.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
